from Products.CMFCore import utils as cmfutils
from StringIO import StringIO

from zope.interface import alsoProvides

from zope.app.component.hooks import setSite
from zope.app.component.interfaces import ISite, IPossibleSite
from Products.Five.site.localsite import enableLocalSiteHook

def setup_gs_profile(portal, out):
    setup_tool = cmfutils.getToolByName(portal, 'portal_setup')
    for extension_id in ['Products.CustomizableTranslations:default']:
        try:
            setup_tool.setImportContext('profile-%s' % extension_id)
            setup_tool.runAllImportSteps()
        except Exception, e:
            print >> out, "error while trying to GS import %s (%s, %s)" \
                          % (extension_id, repr(e), str(e))
    setup_tool.setImportContext('profile-Products.CustomizableTranslations:default')

def enable_hook(portal, out):
    # ensure the local site hook is enabled
    if not IPossibleSite.providedBy(portal):
        alsoProvides(portal, IPossibleSite)

    if not ISite.providedBy(portal):
        enableLocalSiteHook(portal)
        setSite(portal)

def install(portal):
    out = StringIO()

    qi = cmfutils.getToolByName(portal, 'portal_quickinstaller')
    qi.installProducts(['PloneLanguageTool'])

    enable_hook(portal, out)
    setup_gs_profile(portal, out)

    return out.getvalue()
