"""This module allows for importing PO files and making them into
`customized translations`.

See `import_po.txt` for details.
"""

import tempfile

import i18ndude.catalog
from zope.i18n import translate

from Products.CustomizableTranslations.interfaces \
     import ICustomizableTranslationsTool


def do_import(po, site):
    f = tempfile.NamedTemporaryFile()
    f.write(po)
    f.flush()
    catalog = i18ndude.catalog.MessageCatalog(f.name)
    f.close()

    tool = ICustomizableTranslationsTool(site)

    for message in catalog.values():
        msgid = message.msgid
        msgstr = message.msgstr
        domain = catalog.domain
        language = catalog.mime_header['Language-Code']

        if translate(msgid, domain, target_language=language,
                     default='__foo__') != msgstr:
            tool.addMessage(msgid, msgstr, domain, language)
